/*
 * A test for the Dynamic class
 */

#include <stdio.h>
#import "Dynamic.h"

int main (int argc, char *argv[])
{
	NSString *className, *methodName;
	char buffer[80];

	for(;;)
	{
		NSAutoreleasePool *pool = [NSAutoreleasePool new];
		Dynamic *dyn = [Dynamic new];

		/*
		 * first, ask which class to instantiate,
		 * then create an object of that class
		 */
		printf("Class to instantiate? ");
		fflush(stdout);
		if (fgets(buffer, sizeof(buffer), stdin) == NULL)
			break;
		buffer[strlen(buffer)-1] = '\0';
		className = [NSString stringWithCString: buffer];

		NS_DURING
		    if (![dyn createObject: className])
		    {
			printf("Cannot create Object of class '%s'\n", buffer);
			[dyn release];
			continue;
		    }

		NS_HANDLER
		    printf("Exception creating '%s' object: %s\n", buffer,
			[[localException reason] cString]);
		    [dyn release];
		    continue;
		NS_ENDHANDLER


		/*
		 * Now ask the user which method to invoke,
		 * then execute that method.
		 *
		 * This is only a simple example that does not
		 * allow arguments.  See NSInvocation for a more
		 * versatile class than Dynamic in this example!
		 */
		printf("Method to invoke on '%s'? ", buffer);
		fflush(stdout);
		if (fgets(buffer, sizeof(buffer), stdin) == NULL)
			break;
		buffer[strlen(buffer)-1] = '\0';
		methodName = [NSString stringWithCString: buffer];

		NS_DURING
		    printf("Method '%s' returned %p\n", buffer,
			[dyn invokeMethod: methodName]);

		NS_HANDLER
		    printf("Method '%s' could not be invoked: %s\n", buffer,
			[[localException reason] cString]);
		NS_ENDHANDLER

		[dyn release];
		[pool release];
	}

	/*notreached*/
	return 0;
}
